#include "stdio.h"
#include "string.h"
#include "conio.h"
#include "stdlib.h"
#include "ctype.h"
#include "stdarg.h"


/* BSGEDIT 1.0   December 17th, 1993                                     */

/* Notes:     Dont' Make Fun Of My Source Code! |-}                      */

/* 12-12-93 - Ripped apart the save file to find a few things I wanted   */
/*            Drank Mountain Dew all night while playing Doom.           */

/* 12-13-93 - Wrote a short program to change health and armour from the */
/*            command line. Drank More Mountain Dew.  Played More Doom.  */

/* 12-14-93 - Added a dinky menu for my room mate who could and wouldn't */
/*            handle all those command line option. Figured out the keys */
/*            ammo offsets.  Added them to the menu.  Wrote some docs for*/
/*            this thing and comment some of the code.                   */

/* 12-15-93 - Release 0.001                                              */

/* 12-17-93 - Changed the menu around a bit.  Went through the saved file*/
/*            for the version 1.1 and added support for both.  Fixed all */
/*            the modes that could be changed.  Gave the user an option  */
/*            of picking 0 - a signed long int, instead of 999. Re-wrote */
/*            and cleaned up some code. Got tired of working on this,    */
/*            figured it was good enough, so I went to bed.              */

/* 12-18-93 - Release 1.0                                                */


void editgamefile(void);                        /* Edit Menu For DSG File  */
void savegamefile(char *filename, int version); /* Open And Save DSG File  */
void main(int argc, char *argv[]);              /* Duh!                    */
void readgamefile(char *filename, int version); /* Read In DSG File        */
void printstats(void);                          /* Print Current Settings  */
char *checksavefile(char *filename);            /* Check File              */
char *yupnope(int nopeyup);                     /* A Tiny Yup/Nope Routine */
long howmany(char *thing);                      /* A How Many Routine      */
long useit(char *itemname);                     /* An Itty 'Use It Or Not' */
int  checksaveversion(char *filename);          /* Check Version           */


/* These Are The Items/Attributes/Modes I've Worked On So Far */
long health,
     armour,

     bluecard,
     yellowcard,
     redcard,
     blueskull,
     yellowskull,
     redskull,

     knuckles,
     pistol,
     shotgun,
     chaingun,
     rocket,
     plasma,
     bfg,
     chainsaw,

     bulletsleft,
     shellsleft,
     cellsleft,
     rocketsleft,
     bulletsmax,
     shellsmax,
     cellsmax,
     rocketsmax,

     godmode,
     berserkmode,
     blurmode,
     radiationmode,
     computermapmode,
     lightvisormode;

char nameofsavegame[40],
     versioninfo[12];


void main(int argc, char *argv[])
{
  char savefile[80];
  int versionnumber;

  strcpy(savefile, checksavefile(argv[1]));
  versionnumber = checksaveversion(savefile);
  readgamefile(savefile, versionnumber);
  printstats();
  editgamefile();
  savegamefile(savefile, versionnumber);
}


void editgamefile(void)
{
  char pick;
  int stop = 0 ;

  while(!stop)
  {
    gotoxy(62, 22);
    printf("                 ");
    gotoxy(45, 23);
    printf("                                     ");
    gotoxy(45, 24);
    printf("                                     ");
    gotoxy(62,22);


    pick = getche();
    pick = toupper(pick);
    switch(pick)
    {

      case '1' :
                 godmode = howmany("How many tics of God Mode?");
                 gotoxy(28,5);
                 printf("%10ld",godmode);
                 break;

      case '2' :
                 berserkmode = howmany("How many tics of Berserk Mode?")                 ;
                 gotoxy(28,6);
                 printf("%10ld",berserkmode);
                 break;

      case '3' :
                 blurmode = howmany("How many tics of Blur Mode?");
                 gotoxy(28,7);
                 printf("%10ld",blurmode);
                 break;

      case '4' :
                 radiationmode = howmany("How many tics of Radiation Mode?");
                 gotoxy(28,8);
                 printf("%10ld",radiationmode);
                 break;

      case '5' :
                 computermapmode = howmany("How many tics of Computer Map Mode?");
                 gotoxy(28,9);
                 printf("%10ld",computermapmode);
                 break;

      case '6' :
                 lightvisormode = howmany("How many tics of Light Visor Mode?");
                 gotoxy(28,10);
                 printf("%10ld",lightvisormode);
                 break;

      case '7' :

                 bulletsmax = howmany("How many for Maximum Bullets?");
                 gotoxy(28,13);
                 printf("%10ld",bulletsmax);
                 break;

      case '8' :
                 shellsmax = howmany("How many for Maximum Shells?");
                 gotoxy(28,14);
                 printf("%10ld",shellsmax);
                 break;

      case '9' :
                 rocketsmax = howmany("How many for Maximum Rockets?");
                 gotoxy(28,15);
                 printf("%10ld",rocketsmax);
                 break;

      case '0' :
                 cellsmax = howmany("How many for Maximum Cells?");
                 gotoxy(28,16);
                 printf("%10ld",cellsmax);
                 break;

      case 'A' :
                 bulletsleft = howmany("How many Bullets Left?");
                 gotoxy(28,17);
                 printf("%10ld",bulletsleft);
                 break;

      case 'B' :
                 shellsleft = howmany("How many Shells Left?");
                 gotoxy(28,18);
                 printf("%10ld",shellsleft);
                 break;

      case 'C' :
                 rocketsleft = howmany("How many Rockets Left?");
                 gotoxy(28,19);
                 printf("%10ld",rocketsleft);
                 break;

      case 'D' :
                 cellsleft = howmany("How many Cells Left?");
                 gotoxy(28,20);
                 printf("%10ld",cellsleft);
                 break;

      case 'E' :
                 health = howmany("How much Health?");
                 gotoxy(28,23);
                 printf("%10ld",health);
                 break;

      case 'F' :

                 armour = howmany("How much Armour?");
                 gotoxy(28,24);
                 printf("%10ld",armour);
                 break;

      case 'G' :
                 bluecard = useit("Blue Card Key");
                 gotoxy(62,5);
                 printf("%s",yupnope(bluecard) );
                 break;

      case 'H' :
                 yellowcard = useit("Yellow Card Key");
                 gotoxy(62,6);
                 printf("%s",yupnope(yellowcard) );
                 break;

      case 'I' :
                 redcard = useit("Red Card Key");
                 gotoxy(62,7);
                 printf("%s",yupnope(redcard) );
                 break;

      case 'J' :
                 blueskull = useit("Blue Skull Key");
                 gotoxy(62,8);
                 printf("%s",yupnope(blueskull) );
                 break;

      case 'K' :
                 yellowskull = useit("Yellow Skull Key");
                 gotoxy(62,9);
                 printf("%s",yupnope(yellowskull) );
                 break;

      case 'L' :
                 redskull = useit("Red Skull Key");
                 gotoxy(62,10);
                 printf("%s",yupnope(redskull) );
                 break;

      case 'M' :
                 knuckles = useit("Brass Knuckles");
                 gotoxy(62,13);
                 printf("%s",yupnope(knuckles) );
                 break;

      case 'N' :
                 pistol = useit("Pistol");
                 gotoxy(62,14);
                 printf("%s",yupnope(pistol) );
                 break;

      case 'O' :
                 shotgun = useit("ShutGun");
                 gotoxy(62,15);
                 printf("%s",yupnope(shotgun) );
                 break;

      case 'P' :
                 chaingun = useit("ChainGun");
                 gotoxy(62,16);
                 printf("%s",yupnope(chaingun) );
                 break;

      case 'Q' :
                 rocket = useit("Rocket Launcher");
                 gotoxy(62,17);
                 printf("%s",yupnope(rocket) );
                 break;

      case 'R' :
                 plasma = useit("Plasma Gun");
                 gotoxy(62,18);
                 printf("%s",yupnope(plasma) );
                 break;

      case 'S' :
                 bfg = useit("BFG9000");
                 gotoxy(62,19);
                 printf("%s",yupnope(bfg) );
                 break;

      case 'T' :
                 chainsaw = useit("ChainSaw");
                 gotoxy(62,20);
                 printf("%s",yupnope(chainsaw) );
                 break;

      case '*':
                 stop=1;
    }
  }
}



char *checksavefile(char *filename)
{

  FILE *fp;
  char fn[80];

  fp = fopen(filename, "r");    /* Check if user entered full path */
  if(fp)
  {
    fclose(fp);
    return(filename);
  }

  sprintf(fn, "c:\\doomdata\\%s", filename); /* Check if it was only the name */
  fp = fopen(fn, "r");
  if(fp)
  {
    fclose(fp);
    return(fn);
  }

  sprintf(fn, "c:\\doomdata\\doomsav%s.dsg", filename); /* Check if it was only the number */
  fp = fopen(fn, "r");
  if(fp)
  {
    fclose(fp);
    return(fn);
  }

  printf("DSGEDIT 1.0    December 17th, 1993\n\n");
  printf("ERROR: The saved game specified was not found.\n");
  printf("USAGE: DSGEDIT <filename>\n\n");
  printf("Where <filename> may be the full path and filename, the filename only\n");
  printf("or the saved game number.  When using only the name or number, DSGEDIT\n");
  printf("will default to the hard coded C:\\DOOMDATA directory for the file.\n\n");
  printf("Examples: DSGEDIT c:\\doomdata\\doomsave.dsg\n");
  printf("          DSGEDIT doomsav1.dsg\n");
  printf("          DSGEDIT 3\n\n\n");

  exit(0);
  return(fn);
}


int checksaveversion(char *filename)
{
  FILE *fp;

  fp = fopen(filename, "r+b");

  fseek(fp, 24, SEEK_SET);        /* Jump To Offset 24 For Version Number */
  fread(&versioninfo, 11, 1, fp);
  if(strcmp(versioninfo, "version 101") == 0) /* Equal?  Version 101      */
  return(6);
  else return (0);   /* Nope.  Still Using The Old Version.              */
}



void printstats(void)
{
  int vn;

  if(strcmp(versioninfo, "version 101") == 0) /* Equal?  Version 101      */
  vn = 101;
  else vn = 99;

  clrscr();
  gotoxy(10,2);
  printf("Name Of Save File: %s",nameofsavegame);
  gotoxy(54,2);
  printf("Version: %3d",vn);

  gotoxy(10,4);
  printf("Modes          :   Tics Left       Keys           : Have");
  gotoxy(10,5);
  printf("1) God         :  %10ld       G) Blue Card   : %s",godmode,yupnope(bluecard));
  gotoxy(10,6);
  printf("2) Berserk     :  %10ld       H) Yellow Card : %s",berserkmode,yupnope(yellowcard));
  gotoxy(10,7);
  printf("3) Blur        :  %10ld       I) Red Card    : %s",blurmode,yupnope(redcard));
  gotoxy(10,8);
  printf("4) Radiation   :  %10ld       J) Blue Skull  : %s",radiationmode,yupnope(blueskull));
  gotoxy(10,9);
  printf("5) Computer Map:  %10ld       K) Yellow Skull: %s",computermapmode,yupnope(yellowskull));
  gotoxy(10,10);
  printf("6) Light Visor :  %10ld       L) Red Skull   : %s",lightvisormode,yupnope(redskull));
  gotoxy(10,12);
  printf("Ammunition     : Amount Left       Weapons        : Have");
  gotoxy(10,13);
  printf("7) Max Bullets :  %10ld       M) Knuckles    : %s",bulletsmax,yupnope(knuckles));
  gotoxy(10,14);
  printf("8) Max Shells  :  %10ld       N) Pistol      : %s",shellsmax,yupnope(pistol));
  gotoxy(10,15);
  printf("9) Max Rockets :  %10ld       O) ShotGun     : %s",rocketsmax,yupnope(shotgun));
  gotoxy(10,16);
  printf("0) Max Cells   :  %10ld       P) ChainGun    : %s",cellsmax,yupnope(chaingun));
  gotoxy(10,17);
  printf("A) Bullets Left:  %10ld       Q) Rocket      : %s",bulletsleft,yupnope(rocket));
  gotoxy(10, 18);
  printf("B) Shells Left :  %10ld       R) Plasma      : %s",shellsleft,yupnope(plasma));
  gotoxy(10,19);
  printf("C) Rockets Left:  %10ld       S) BFG9000     : %s",rocketsleft,yupnope(bfg));
  gotoxy(10,20);
  printf("D) Cells Left  :  %10ld       T) ChainSaw    : %s",cellsleft,yupnope(chainsaw));
  gotoxy(10,22);
  printf("Attributes     : Amount Left       Choice (*=Quit): ");
  gotoxy(10,23);
  printf("E) Health      :  %10ld",health);
  gotoxy(10,24);
  printf("F) Armour      :  %10ld",armour);
}

void readgamefile(char *filename, int version)
{
  FILE *fp;

  fp = fopen(filename, "r+b");

  fseek(fp,  (0+version), SEEK_SET); /*         Beginning Of File          */

  fread(&nameofsavegame, 23, 1, fp); /*      Name Of Save Game: Offset   0 */

  fseek(fp, (86+version), SEEK_SET); /*            Attributes              */

  fread(     &health, 4, 1, fp);     /*                 Health: Offset  86 */
  fread(     &armour, 4, 1, fp);     /*                 Armour: Offset  90 */


  fseek(fp, (98+version), SEEK_SET); /*              Modes                 */

  fread(        &godmode, 4, 1, fp); /*               God Mode: Offset  98 */
  fread(    &berserkmode, 4, 1, fp); /*           Berserk Mode: Offset 102 */
  fread(       &blurmode, 4, 1, fp); /*              Blue Mode: Offset 106 */
  fread(  &radiationmode, 4, 1, fp); /*         Radiation Mode: Offset 110 */
  fread(&computermapmode, 4, 1, fp); /*      Computer Map Mode: Offset 114 */
  fread( &lightvisormode, 4, 1, fp); /*  Light Amp. Visor Mode: Offset 118 */


  fseek(fp, (122+version), SEEK_SET);/*        Card And Skull Keys         */

  fread(   &bluecard, 4, 1, fp);     /*          Blue Card Key: Offset 122 */
  fread( &yellowcard, 4, 1, fp);     /*        Yellow Card Key: Offset 126 */
  fread(    &redcard, 4, 1, fp);     /*           Red Card Key: Offset 130 */
  fread(  &blueskull, 4, 1, fp);     /*         Blue Skull Key: Offset 134 */
  fread(&yellowskull, 4, 1, fp);     /*       Yellow Skull Key: Offset 138 */
  fread(   &redskull, 4, 1, fp);     /*          Red Skull Key: Offset 142 */


  fseek(fp, (174+version), SEEK_SET);/*              Weapons               */

  fread(   &knuckles, 4, 1, fp);     /*         Brass Knuckles: Offset 174 */
  fread(     &pistol, 4, 1, fp);     /*                 Pistol: Offset 178 */
  fread(    &shotgun, 4, 1, fp);     /*                Shotgun: Offset 182 */
  fread(   &chaingun, 4, 1, fp);     /*               Chaingun: Offset 186 */
  fread(     &rocket, 4, 1, fp);     /*        Rocket Launcher: Offset 190 */
  fread(     &plasma, 4, 1, fp);     /*             Plasma Gun: Offset 194 */
  fread(        &bfg, 4, 1, fp);     /*                BFG9000: Offset 198 */
  fread(   &chainsaw, 4, 1, fp);     /*               Chainsaw: Offset 202 */


  fseek(fp, (206+version), SEEK_SET);/*                Ammo                */

  fread(&bulletsleft, 4, 1, fp);     /*           Bullets Left: Offset 206 */
  fread( &shellsleft, 4, 1, fp);     /*    Shotgun Shells Left: Offset 210 */
  fread(  &cellsleft, 4, 1, fp);     /*             Cells Left: Offset 214 */
  fread(&rocketsleft, 4, 1, fp);     /*           Rockets Left: Offset 218 */
  fread( &bulletsmax, 4, 1, fp);     /*        Maximum Bullets: Offset 222 */
  fread(  &shellsmax, 4, 1, fp);     /* Maximum Shotgun Shells: Offset 226 */
  fread(   &cellsmax, 4, 1, fp);     /*          Maximum Cells: Offset 230 */
  fread( &rocketsmax, 4, 1, fp);     /*        Maximum Rockets: Offset 234 */

  fclose(fp);
}


void savegamefile(char *filename, int version)
{
  FILE *fp;
  char pick;

  gotoxy(45,23);
  printf("Save this configuration? (Y/N) ");
  pick = getche();
  pick = toupper(pick);
  if(pick == 'Y')
  {

    fp = fopen(filename, "r+b");


    fseek(fp, (86+version), SEEK_SET);  /*            Attributes              */

    fwrite(     &health, 4, 1, fp);     /*                 Health: Offset  86 */
    fwrite(     &armour, 4, 1, fp);     /*                 Armour: Offset  90 */

    fseek(fp, 98+version, SEEK_SET);    /*              Modes                 */

    fwrite(        &godmode, 4, 1, fp); /*               God Mode: Offset  98 */
    fwrite(    &berserkmode, 4, 1, fp); /*           Berserk Mode: Offset 102 */
    fwrite(       &blurmode, 4, 1, fp); /*              Blue Mode: Offset 106 */
    fwrite(  &radiationmode, 4, 1, fp); /*         Radiation Mode: Offset 110 */
    fwrite(&computermapmode, 4, 1, fp); /*      Computer Map Mode: Offset 114 */
    fwrite( &lightvisormode, 4, 1, fp); /*  Light Amp. Visor Mode: Offset 118 */

    fseek(fp, 122+version, SEEK_SET);   /*        Card And Skull Keys         */

    fwrite(   &bluecard, 4, 1, fp);     /*          Blue Card Key: Offset 122 */
    fwrite( &yellowcard, 4, 1, fp);     /*        Yellow Card Key: Offset 126 */
    fwrite(    &redcard, 4, 1, fp);     /*           Red Card Key: Offset 130 */
    fwrite(  &blueskull, 4, 1, fp);     /*         Blue Skull Key: Offset 134 */
    fwrite(&yellowskull, 4, 1, fp);     /*       Yellow Skull Key: Offset 138 */
    fwrite(   &redskull, 4, 1, fp);     /*          Red Skull Key: Offset 142 */

    fseek(fp, 174+version, SEEK_SET);   /*              Weapons               */

    fwrite(   &knuckles, 4, 1, fp);     /*         Brass Knuckles: Offset 174 */
    fwrite(     &pistol, 4, 1, fp);     /*                 Pistol: Offset 178 */
    fwrite(    &shotgun, 4, 1, fp);     /*                Shotgun: Offset 182 */
    fwrite(   &chaingun, 4, 1, fp);     /*               Chaingun: Offset 186 */
    fwrite(     &rocket, 4, 1, fp);     /*        Rocket Launcher: Offset 190 */
    fwrite(     &plasma, 4, 1, fp);     /*             Plasma Gun: Offset 194 */
    fwrite(        &bfg, 4, 1, fp);     /*                BFG9000: Offset 198 */
    fwrite(   &chainsaw, 4, 1, fp);     /*               Chainsaw: Offset 202 */

    fseek(fp, 206+version, SEEK_SET);   /*                Ammo                */

    fwrite(&bulletsleft, 4, 1, fp);     /*           Bullets Left: Offset 206 */
    fwrite( &shellsleft, 4, 1, fp);     /*    Shotgun Shells Left: Offset 210 */
    fwrite(  &cellsleft, 4, 1, fp);     /*             Cells Left: Offset 214 */
    fwrite(&rocketsleft, 4, 1, fp);     /*           Rockets Left: Offset 218 */
    fwrite( &bulletsmax, 4, 1, fp);     /*        Maximum Bullets: Offset 222 */
    fwrite(  &shellsmax, 4, 1, fp);     /* Maximum Shotgun Shells: Offset 226 */
    fwrite(   &cellsmax, 4, 1, fp);     /*          Maximum Cells: Offset 230 */
    fwrite( &rocketsmax, 4, 1, fp);     /*        Maximum Rockets: Offset 234 */

    fclose(fp);
    clrscr();
  }
  else
  {
    clrscr();
    exit(0);
  }
}


long howmany(char *thing)
{
   long mode;

   gotoxy(62,22);
   printf("                  ");
   gotoxy(45,23);
   printf("%s",thing);
   gotoxy(45,24);
   printf("(Available Options: 0 - 2147483647)");
   gotoxy(62,22);
   scanf("%li", &mode);
   return(mode);
}

long useit(char *itemname)
{
  char pick;

  gotoxy(62,22);
  printf("                   ");
  gotoxy(45,23);
  printf("Use the %s? (Y/N) ", itemname);
  pick = getche();
  pick = toupper(pick);
  if(pick == 'Y') return(1);
  else return(0);
}

char *yupnope(int nopeyup)
{
  if(nopeyup) return("Yup!");
  else return("Nope");
}
